//ModifierUnStyle_201f.js
// 11.06.08 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Sert  modifier une feuille de style de paragraphe ou de caractre selon un modle

if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// tester la slection
try {
	var curType = app.selection[0].constructor.name;
	if (curType != "InsertionPoint" && curType != "Character" && curType != "Text" && curType != "Word" 
		&& curType != "Line" && curType != "Paragraph" && curType != "TextColumn" && curType != "TextStyleRange") {
		alert ("Il faut slectionner un peu de texte.", "Attention");
		exit ();
	}
}
catch (e) {
	alert ("Il n'y a pas de slection.", "Attention");
	exit();
}

//--- dresser la liste des feuilles de style de paragraphes ---//
var allParaStyles = app.documents[0].paragraphStyles.everyItem().name;
// supprimer le contenu du premier lment
allParaStyles[0] = "";

//--- dresser la liste des feuilles de style de caractres ---//
var allCharStyles = app.documents[0].characterStyles.everyItem().name;
// supprimer le contenu du premier lment
allCharStyles[0] = "";

// effacer des dialogues qui sont ventuellement rests dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// crer un dialogue
var aDialog = app.dialogs.add({name:"Slectionner le style  modifier", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Feuille de style de paragraphes:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var paraName = dropdowns.add({stringList:allParaStyles, selectedIndex:0, minWidth:180});
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Feuille de style de caractres:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var charName = dropdowns.add({stringList:allCharStyles, selectedIndex:0, minWidth:180});
			}
		}
	}
	with (dialogColumns.add()) {
		staticTexts.add({staticLabel:"", minWidth:4});
	}
}
// montrer le dialogue
if (aDialog.show() == true) {
	// reprendre les choix de l'utilisateur
	paraID = paraName.selectedIndex;
	charID = charName.selectedIndex;
	// effacer le dialogue de la mmoire
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// tester le choix de l'utilisateur
if (paraID != 0 && charID != 0) {
	alert ("Il ne faut pas slectionner un article de chaque.", "Stop");
	exit();
}

// relever les attributs de la slection
var newProps = app.selection[0].properties;

// modifier la feuille de style correspondante
if (paraID != 0) {
	var curPara = allParaStyles[paraID];
	app.documents[0].paragraphStyles.item(curPara).properties = newProps;
}
else if (charID != 0) {
	var curChar = allCharStyles[charID];
	app.documents[0].characterStyles.item(curChar).properties = newProps;
}
